import { ResultAsync, Result } from "neverthrow";
export declare class ResultUtils {
    static combine<T, T2, T3, T4, E, E2, E3, E4>(asyncResultList: [
        ResultAsync<T, E>,
        ResultAsync<T2, E2>,
        ResultAsync<T3, E3>,
        ResultAsync<T4, E4>
    ]): ResultAsync<[T, T2, T3, T4], E | E2 | E3 | E4>;
    static combine<T, T2, T3, E, E2, E3>(asyncResultList: [
        ResultAsync<T, E>,
        ResultAsync<T2, E2>,
        ResultAsync<T3, E3>
    ]): ResultAsync<[T, T2, T3], E | E2 | E3>;
    static combine<T, T2, E, E2>(asyncResultList: [ResultAsync<T, E>, ResultAsync<T2, E2>]): ResultAsync<[T, T2], E | E2>;
    static combine<T, E>(asyncResultList: ResultAsync<T, E>[]): ResultAsync<T[], E>;
    static combineResultList<T, E>(resultList: Result<T, E>[]): Result<T[], E>;
    static race<T, E>(asyncResultList: ResultAsync<T, E>[]): ResultAsync<T, E>;
    static resultRace<T, E>(result: Result<T, E>): Result<T, E>;
    static fromThrowableResult<T, E>(throwableCallback: () => T): Result<T, E>;
    static executeSerially<T, E>(funcList: (() => ResultAsync<T, E>)[]): ResultAsync<T[], E>;
    static backoffAndRetry<T, E extends Error>(func: () => ResultAsync<T, E>, acceptableErrors: Function[], maxAttempts?: number, baseSeconds?: number): ResultAsync<T, E>;
    static filter<T, E extends Error>(arr: T[], callback: (val: T) => ResultAsync<boolean, E>): ResultAsync<T[], E>;
    static map<T, U, E extends Error>(arr: T[], callback: (val: T) => ResultAsync<U, E>): ResultAsync<U[], E>;
}
//# sourceMappingURL=ResultUtils.d.ts.map